defmodule Clickhouse.Format do
  @moduledoc """
  A behaviour to implement data formatting of Clickhouse queries and results.
  """

  @callback decode(Clickhouse.Result.t()) ::
              {:ok, Clickhouse.Result.t()} | {:error, Clickhouse.Error.t()}

  @callback encode(Clickhouse.Query.t()) ::
              {:ok, Clickhouse.Query.t()} | {:error, Clickhouse.Error.t()}
end
